//****************************************************************************
//	aisa57s.pas
//
//	aISA-A57Tv\[X
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	Date 1998/07/10
//
//	̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B
//
//****************************************************************************
unit aisa57s;

interface

uses
	Windows, Messages, SysUtils, Forms, aisa57w;

const
	szTitle = 'Sample';
	szA57	 = 'aISA-A57';

type
	TForm1 = class(TForm)
		procedure FormCreate(Sender: TObject);
	private
		procedure ResultMessage(strbuf: String);
		procedure ErrorMessage(wLogSlot: Word);
	public
		{ Public 錾 }
	end;

var
	Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var
	strbuf:	 String;
	dwDLLVer,	 dwDrvVer: DWord;
	bResult:	 Boolean;						// 
	wLogSlot:	 Word;							// foCXi[
	ri:				 TAISA57RESOURCE;	// \[X
	md:				 TAISA57MODE;			// TvO[h
	dwNumData: DWord;
	dwStatus:	 DWord;
	Data:			 TVXDBUFF;
	wDaData:   Word;					  // D/Af[^
	InValue:   Byte;						// PIOf[^
  OutValue:  Byte;
	i:				 Integer;
	hWnd:			 THandle;
	InitArg:	DWord;
begin
//---------------------------------------------------------------------------
	// aisa57.dll ̎gp錾
	if Aisa57wDllOpen() = False then
	begin
		ErrorMessage(AISA57_SLOT_AUTO);
		Halt;			// aisa57.dll ̃[hɎs܂
	end;

//---------------------------------------------------------------------------
	// o[Wԍ\
	// aISA-A57 DLL,Driver̃o[Wԍ擾
	if Aisa57wGetVersion(dwDLLVer, dwDrvVer) = False then
	begin
		ErrorMessage(AISA57_SLOT_AUTO);
		Halt;
	end;

	strbuf := Format('GetVersion'#10 +
					 'DLL Version: %08xH'#10 +
					 'Driver Version: %08xH',
										 [dwDLLVer, dwDrvVer]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// aISA-A57̎gp錾
	wLogSlot := AISA57_SLOT_AUTO;		// gp̃foCXT܂B
	hWnd		:= 0;
	InitArg := 0;
	bResult := Aisa57wCreate(wLogSlot,	// ꍇA̎̃foCXi[܂B
							hWnd,							// EBhEnhȂ̂NULLZbg܂B
																// EBhEnhZbg΁A
																// e탁bZ[W܂B
							$6401,						// 3ԖڂɃZbgẮAbZ[WID̊
																// ƂȂlłBۂ̃bZ[WID͂̊lɃI
																// tZbg(WM_EOCȂ)̂ƂȂ܂B
							InitArg);

	if bResult = False then		// foCX܂B
	begin
		ErrorMessage(AISA57_SLOT_AUTO);
		Halt;
	end;

	strbuf := Format('aISA-A57 Created'#10#10 +
									 'LogSlot: %2d', [wLogSlot]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// \[X擾
	if Aisa57wGetResource(wLogSlot, @ri) = False then
	begin
		ErrorMessage(wLogSlot);
		Halt;
	end;

	strbuf := Format('Board Name: %s'#10 +
									 'IO Base Address: %04xH-%04xH'#10 +
									 'IRQ: %2d',
										 [szA57, ri.dwIOPortBase[1],
											ri.dwIOPortBase[1] + ri.dwIOPortLength[1] - 1,
											ri.dwIRQRegisters[1]]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
//	A/D 
//---------------------------------------------------------------------------
	// TvO[h̐ݒ
	md.dwChFirst := 0;		// TvOJn`l(0 ` 7)
	md.dwChLast	:=  7;		// TvOI`l(0 ` 7)
	md.cwBuffer := 256;		// obt@TCYi[hPʁj
	md.dwTimer	:= $27;		// ^C}l({[h}jAP.27Q)
	md.dwMode		:= AISA57_MODE_02;	// 샂[h(1`4)

	if Aisa57wSetMode(wLogSlot, @md) = False then
	begin
		ErrorMessage(wLogSlot);
		Halt;
	end;

	strbuf := Format('aISA-A57 Sampling Mode'#10 +
									 'TvOJn`l=%d'#10 +
									 'TvOI`l=%d'#10 +
									 'obt@TCY=%d'#10 +
									 '^C}l=%02xH'#10 +
									 '샂[h=%d',
									 [md.dwChFirst, md.dwChLast, md.cwBuffer,
										md.dwTimer, md.dwMode]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// TvOJn
	if Aisa57wStartSampling(wLogSlot) = False then
	begin
		ErrorMessage(wLogSlot);
		Halt;
	end;

	ResultMessage('aISA-A57 Sampling Started');

//---------------------------------------------------------------------------
	// TvO~
	if Aisa57wStopSampling(wLogSlot) = False then
	begin
		ErrorMessage(wLogSlot);
		Halt;
	end;

	ResultMessage('aISA-A57 Sampling Stopped');

//---------------------------------------------------------------------------
	// TvOEXe[^X̎擾
	if Aisa57wGetSamplingStatus(wLogSlot, dwNumData, dwStatus) = False then
	begin
		ErrorMessage(wLogSlot);
		Halt;
	end;

	strbuf := Format('TvOEXe[^X擾'#10 +
									 'f[^=%d'#10 +
									 'Xe[^X=%d',
									 [dwNumData, dwStatus]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// TvOς݃f[^̎擾
	if dwNumData > 0 then
	begin
		for i:=1 to (AISA57_ADCH_MAX)*(AISA57_BUFF_PCH_MAX-1) do Data[i]:=0;

		if Aisa57wGetData(wLogSlot, dwNumData, @Data) = False then
		begin
			ErrorMessage(wLogSlot);
			Halt;
		end;

    if dwNumData > 99 then dwNumData := 99;	// f[^99ҏW甲悤ɂ

		strbuf := 'TvOς݃f[^擾'#10;
		for i := 1 to dwNumData -1 do
		begin
			strbuf := strbuf + Format('%d:%.xH	', [i, Data[i]]);

			if (i + 1) mod 4 = 0 then	// 4 Ŋ؂
				strbuf := strbuf + #10;
		end;

		ResultMessage(strbuf);
	end;

//---------------------------------------------------------------------------
//	D/A 
//---------------------------------------------------------------------------
	// o̓f[^̐ݒ
	wDaData := $0FFF;

	if Aisa57wSetData(wLogSlot, AISA57_DACH_01, wDaData) = False then
	begin
		ErrorMessage(wLogSlot);
		Halt;
	end;

	strbuf := Format('D/Af[^o'#10 +
									 'D/A Data: %02xH',
									 [wDaData]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
//	PIO 
//---------------------------------------------------------------------------
	// Cӂ̃f[^o
	// o̓f[^ AAh
	OutValue := Byte($AA);

	if Aisa57wOutPort(wLogSlot, OutValue) = False then
	begin
		ErrorMessage(wLogSlot);
		Halt;
	end;

	strbuf := Format('f[^o'#10 +
									 'Out Data: %02xH',
									 [OutValue]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// f[^ǂݍ
	InValue := Byte($00);

	if Aisa57wInPort(wLogSlot, InValue) = False then
	begin
		ErrorMessage(wLogSlot);
		Halt;
	end;

	strbuf := Format('f[^'#10 +
									 'In Data: %02xH',
									 [InValue]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// aISA-A57̎gpJ
	if Aisa57wClose(wLogSlot) = False then
	begin
		ErrorMessage(wLogSlot);
		Halt;
	end;

	ResultMessage('aISA-A57 Closed');

	// aisa57.dll ̎gpJ
	if Aisa57wDllClose() = False then
	begin
		Application.MessageBox(PChar('DLL ̃A[hɎs܂B'), szTitle, MB_OK + MB_ICONSTOP);
		Halt;			// aisa57.dll ̃A[hɎs܂B
	end;

end;

// ʂ\
procedure TForm1.ResultMessage(strbuf: String);
begin
	Application.MessageBox(PChar(strbuf), szTitle, MB_OK + MB_ICONINFORMATION);
end;

// G[bZ[W\
procedure TForm1.ErrorMessage(wLogSlot: Word);
var
	dwRes: DWord;
	strbuf: String;
begin
	dwRes := Aisa57wGetLastError(wLogSlot);

	case dwRes of
		AISA57_ERR_WRAPDLL:
			strbuf := 'DLL Load error';
	else
		strbuf := Format('aISA-A57 error'#10#10'Error code: %08xH',[dwRes]);
	end;

	Application.MessageBox(PChar(strbuf), szTitle, MB_OK + MB_ICONSTOP);
end;

end.
